#include <exec/types.h>
#include <devices/audio.h>
#include "sample.h"
#include "sounds.h"

extern Sample eagle1Sample, eagle2Sample, saucerSample;
extern Sample crashSample, xthrustSample, ythrustSample;

Sound eagle1sound = {"eagle1", &eagle1Sample, 1, 64, LEFT, 0, 0};
Sound eagle2sound = {"eagle2", &eagle2Sample, 1, 64, RIGHT, 0, 0};
Sound saucersound = {"saucer", &saucerSample, 0, 32, LEFT|EITHER, -7, 0};
Sound lcrashsound = {"lcrash", &crashSample, 1, 64, LEFT, 0, 0};
Sound rcrashsound = {"rcrash", &crashSample, 1, 64, RIGHT, 0, 300};
Sound lxthrustsound = {"lxthrust", &xthrustSample, 0, 32, LEFT, -10, 0};
Sound rxthrustsound = {"rxthrust", &xthrustSample, 0, 32, RIGHT, -10, 0};
Sound lythrustsound = {"lythrust", &ythrustSample, 0, 48, LEFT, -5, 0};
Sound rythrustsound = {"rythrust", &ythrustSample, 0, 48, RIGHT, -5, -1500};

